     h Option(*SRCSTMT) DftActGrp(*no) ActGrp(*caller)
     h main(RplStr)
       //===========================================================
       // Replaces all occurrence of string pFrom with string pTo in
       // the given CL variable pStr.
       //===========================================================
       // RPLSTRR is the CPP for the RPLSTR and FIXQTE commands.
       // Called from the commands so all three parms are assumed
       // to be present.

       // 32767 is the max size allowed on a CL *CHAR variable.
       // Each parameter is defined as VARY(*YES) in the command and
       // is received here as a 2 byte field length followed by the
       // characters in the field. Thus they can be treated as RPG
       // varying fields by basing them on pointers.

     d RplStr          pr                  extpgm('RPLSTRR')
     d                            32767a   options(*varsize)
     d                            32767a   options(*varsize)
     d                            32767a   options(*varsize)

     p RplStr          b
     d RplStr          pi
     d pStr                       32767a   options(*varsize)
     d pFrom                      32767a   options(*varsize)
     d pTo                        32767a   options(*varsize)

       // Parameters as RPG varying fields
     d vStr            s          32767a   varying based(ptrStr)
     d vFrom           s          32767a   varying based(ptrFrom)
     d vTo             s          32767a   varying based(ptrTo)

     d ptrStr          s               *
     d ptrFrom         s               *
     d ptrTo           s               *

     d wStr            s          32767a   varying

      /free
       // Make parameters look like varying fields
       ptrStr = %addr(pStr);
       ptrFrom = %addr(pFrom);
       ptrTo = %addr(pTo);

       // Make changes in work field to avoid increased length issues
       wStr = vStr;
       wStr = %scanrpl(vFrom : vTo : wStr);

       // Can't lengthen input string, otherwise we corrupt memory,
       // so truncate new string if necessary.
       if %len(wStr) <= %len(vStr);
           vStr = wStr;
       else;
           vStr = %subst(wStr: 1 : %len(vStr));
       endif;
       *inlr = *on;
      /end-free
     pRplStr           e



